/* Compact floating-point encoding, manual test program.
   Written by Radford M. Neal, 2015. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cflt.h"

int cflt_args (char **);

int main (int argc, char **argv)
{
  double flt, dec;
  cflt_t enc;

  if (cflt_args(argv) != 0)
  { 
#   if CFLT_2_MASKS | CFLT_RECODE
      fprintf(stderr,
              "Usage:  cflt[234]-test bits bits2 epos { NA | n/m | n.m }\n");
#   else
      fprintf(stderr,"Usage:  cflt1-test bits { NA | n/m | n.m }\n");
#   endif
    exit(1);
  }

  while (printf("Enter number: "), scanf("%lf",&flt) == 1)
  { if (cflt_encode(flt,&enc))
    { dec = cflt_decode(enc);
      printf (dec == flt ? "Compression worked\n" : "Compression failed\n");
    }
    else
    { printf("Can't compress\n");
    }
  }

  return 0;
}
