/* Compact floating-point encoding, test program that just uses values.
   Written by Radford M. Neal, 2015. */

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#include "cflt.h"

int cflt_args (char **);

int main (int argc, char **argv)
{
  char *file = NULL;
  int32_t w;
  int i;

# if !CFLT_INDIRECT & !CFLT_RECODE
    if (argc>2 && strcmp(argv[1],"-o")==0) 
    { file = argv[2];
      argc -= 2;
      argv += 2;
    }
# endif

  if (cflt_args(argv) != 0)
  {
#   if CFLT_2_MASKS | CFLT_RECODE
#     if CFLT_RECODE | CFLT_INDIRECT
        fprintf(stderr,
                "Usage:  cflt[234]-use bits bits2 epos { NA | n/m | n.m }\n");
#     else
        fprintf(stderr,
  "Usage:  cflt[234]-use [ -o tbl-file ] bits bits2 epos { NA | n/m | n.m }\n");
#     endif
#   else
      fprintf (stderr,
               "Usage:  cflt1-use [ -o tbl-file ] bits { NA | n/m | n.m }\n");
#   endif
    exit(1);
  }

  if (file)
  { FILE *tbl_file = fopen(file,"w");
    if (tbl_file==NULL)
    { fprintf (stderr, "Can't create file %s\n", file);
      exit(1);
    }
    for (i = 0; i < 1<<(cflt_bits+cflt_bits2); i++)
    { fprintf (tbl_file, "%05x %08x\n", i, cflt_table[i]);
    }
  }

  exit(0);
}
